function alignTDirToFDir(links)
//
// process incoming database to find reverse topology on one way facilities 
// this uses state based rules and specific conventions
// direction cannot be conclusively determined so warnings are issued
//
// when LINKERR is updated with a value of 2 (for any link), those links are automatically reversed.
// this suspends the interactive mode and prompts
//
{
   var cases=new Array();
   var ignore=new Array(2);
   ignore[0]=["routes"];
   ignore[1]=[0];
   var forceupd=false;
   reportWrite("\n\n (Information) Topology Exceptions Report\n");
   var count=0;
   for (var link=1;link<links.length;link++)
   {
      if (state=="Colorado") 
      {
         var twoway=false;
         var reverse=false;
         var matchbuffer=.002;
//
// first test for off system link by route id
//
         var fc=links[link].properties.F_SYSTEM;
         var ft=links[link].properties.FACILITY_T;
         var rid=links[link].properties.ROUTE_ID;
         var rnm=links[link].properties.ROUTE_NAME;
         var rno=parseInt(rid);
         var acoord=links[link].geometry.coordinates[0];
         var bcoord=links[link].geometry.coordinates[links[link].geometry.coordinates.length-1];
         if(rid.substr(4,1)=="-") return (true);
         var which=rno%2;
//
// get link angle for segment
//
         var angle=turf.bearing(turf.point(acoord),turf.point(bcoord));
         if (angle<0) angle=angle+360;

//
// if arterial then look for an opposite direction overlay using the "DEC" code to identify
//
//
// the one way segment coding is applied to arterials that are state hwys
//
         if (check2WayFlow(link,links)) 
         {
            reverse=false;
            twoway=true;
         }
//
// check angle for even/odd route IDs when one flow direction coded (DEC = SB or WB)
//
         if (fc<=3 && ft!=4 && ft!=5 && !twoway)
         { 
            if (which==0) 
            {
               if (rid.substr(rid.length-3,3)=="DEC" && angle<=180) reverse=true;
               else if (rid.substr(rid.length-3,3)!="DEC" && angle>180) reverse=true;
            }
            if (which==1) 
            {
               if (rid.substr(rid.length-3,3)=="DEC" && (angle>=270 || angle<=90)) reverse=true;
               else if (rid.substr(rid.length-3,3)!="DEC" && (angle<270 && angle>90)) reverse=true;
            }
//
// invert coordinate list if not same as flow via confirm prompt
//
            if (reverse) 
            {
               reportWrite("(Warning) Inverse direction coding likely LinkID = "+link.toString()+" ["+rid+"]");
               var timer=setTimeout("parent.settings.history(0)",1000);
               if (links[link].properties.LINKERR!=2) links[link].properties.LINKERR=1;
               else forceupd=true;
               cases.push([link,rid]);
               if (ignore[0].indexOf(rid)==-1) 
               {
                   ignore[0].push(rid);
                   ignore[1].push(0);               
               }
               count++;
            }
         }
      }
   }
   if (timer) clearTimeout(timer);
//
// COLORADO - END
//
//
// no updating for any unlisted state 
//
   reportWrite("\n(Information) End Topology Exceptions Report ("+count.toString()+" exceptions found)\n");
//
// if web based, invoke link update dialog
//
   if (webenable && count>0)
   {

      if (!forceupd) run=confirm(count.toString()+" Errors - Reorder Coordinate Lists?");
      else run=true;
      if (run)
      {
         for (var i=0;i<cases.length;i++)
         {
            var invert=false;
            if (forceupd)
            {
               if (links[cases[i][0]].properties.LINKERR=2) invert=true;
            } 
            if (!invert && !forceupd && ignore[1][ignore[0].indexOf(cases[i][1])]!=1) 
            {
               invert=confirm((i+1).toString()+". Reorder "+cases[i][0].toString()+" ["+cases[i][1]+"] Coordinates?");
               blist=confirm("Ignore all other links with route id ["+cases[i][1]+"]?");
               if (blist && ignore[1][ignore[0].indexOf(cases[i][1])]==0) ignore[1][ignore[0].indexOf(cases[i][1])]=1;
               else ignore[1][ignore[0].indexOf(cases[i][1])]=2;  
            }
            if (invert) 
            {
               var clength=links[cases[i][0]].geometry.coordinates.length;
               var rcoor=new Array(clength);
               for (var j=0;j<clength;j++)
               {
                  rcoor[j]=links[cases[i][0]].geometry.coordinates[clength-j-1];
               }
               links[cases[i][0]].geometry.coordinates=rcoor; 
               reportWrite("(Information) LinkID = "+cases[i][0].toString()+" ["+cases[i][1]+"] reordered");
               links[cases[i][0]].properties.LINKERR=0;
            }
         }
      }
   }
   return;
}
