function checkAngles(olinks,onode,olink,ilinks,snode,slink,reverse,dircode)
//
// this routine calculates and compares exit angles for the links input. the calculation
// considers the assumed direction of the angle and adjusts for topology
// reserve flag handles "end of link" angles 
//
// first, get nodes/links in right order and find angles 
//
{
   if (reverse==null) reverse=false;
   var sb=getBNode(snode,slink,ilinks);
   var sp=ilinks[slink].geometry.coordinates;
   if (sb[1]=="AB") 
   { 
      var sloc=sp[1];
      if (!reverse) var sangle=turf.bearing(turf.point(sp[0]),turf.point(sp[1]));
      else var sangle=turf.bearing(turf.point(sp[1]),turf.point(sp[0]));
      if (sangle<0) sangle=sangle+360;
   }
   else
   {
      var sloc=sp[sp.length-1];
      if (!reverse) var sangle=turf.bearing(turf.point(sp[sp.length-1]),turf.point(sp[sp.length-2]));
      else var sangle=turf.bearing(turf.point(sp[sp.length-2]),turf.point(sp[sp.length-1]));
      if (sangle<0) sangle=sangle+360;
   }
//   
   var tb=getBNode(onode,olink,olinks);
   tp=copyArray(olinks[olink].geometry.coordinates);
   var tpl=tp.length;
//
// use point list to find nearest points to source point location
//
   for (var i=0;i<tpl;i++) tp[i]=[turf.distance(sloc,tp[i],{units: 'miles'}),tp[i],i];
   tp=tp.sort(function(a,b) {return a[0]-b[0]});
   if (!reverse) var tangle=turf.bearing(turf.point(tp[0][1]),turf.point(tp[1][1]));
   else var tangle=turf.bearing(turf.point(tp[tp.length-2][1]),turf.point(tp[tp.length-1][1]));
   if (tangle<0) tangle=tangle+360;
//
// after the sort, there can be four conditions to test for - two confirm tangle
//
   if (!reverse)
   {
      if (tp[0][2]<tp[1][2] && tb[1]=="BA") tangle=tangle+180%360;
      else if (tp[0][2]>tp[1][2] && tb[1]=="AB") tangle=tangle+180%360;
   }
   else
   {
      if (tp[tp.length-1][2]<tp[tp.length-2][2] && tb[1]=="BA") tangle=tangle+180%360;
      else if (tp[tp.length-2][2]>tp[tp.length-1][2] && tb[1]=="AB") tangle=tangle+180%360;
   }
   diffang=180-Math.abs(180-Math.abs(sangle-tangle));
   if (diffang>arctol) return null;
//
// start state specific rules criteria block
//
//
// handling for Alabama coding
//
   if (state=="Alabama")
   {
   }
//
// handling for Alaska coding
//
   if (state=="Alaska")
   {
   }
//
// handling for Arizona coding
//
   if (state=="Arizona")
   {
   }
//
// handling for Arkansas coding
//
   if (state=="Arkansas")
   {
   }
//
// handling for California coding
//
   if (state=="California")
   {
   }
//
// handling for Colorado coding
//
   if (state=="Colorado")
   {
      var fc=olinks[olink].properties.F_SYSTEM;
      var ft=olinks[olink].properties.FACILITY_T;
      var rid=olinks[olink].properties.ROUTE_ID;
      var rno=parseInt(olinks[olink].properties.ROUTE_ID);
//
// the one segment coding is applied to arterials that are state hwys
//
      if (check2WayFlow(olink,olinks)) 
      {
         clerror[6]="Pass";
         return olink;
      }
//
// test for directional or two way segment coding of arterials (F_SYSTEM=3)
//
      if (fc==3 && rid.substr(rid.length-3,3)!="DEC")  
         if (aID.indexOf(rid+"_DEC")==-1) test=false;
//
// check angle for even/odd route IDs when one flow direction coded (DEC = SB or WB)
//
      clerror[6]="Pass";
      if (fc<=3)
      {
//
// for CO, exclude ramps/ono-mainline
//
         if (ft!=4 && ft!=5)
         { 
            var which=rno%2;
            if (which==0) 
            {
               if (rid.substr(rid.length-3,3)=="DEC" && sangle<=180) clerror[6]="Fail";
               else if (rid.substr(rid.length-3,3)!="DEC" && sangle>180) clerror[6]="Fail";
            }
            if (which==1) 
            {
               if (rid.substr(rid.length-3,3)=="DEC" && (sangle>=270 || sangle<=90)) clerror[6]="Fail";
               else if (rid.substr(rid.length-3,3)!="DEC" && (sangle<270 && sangle>90)) clerror[6]="Fail";
            }
         }
         else clerror[6]="Fail";
      }
   }

//
// handling for Connecticut coding
//
   if (state=="Connecticut")
   {
   }
//
// handling for Delaware coding
//
   if (state=="Delaware")
   {
   }
//
// handling for DistrictofColumbia coding
//
   if (state=="DistrictofColumbia")
   {
   }
//
// handling for Florida coding
//
   if (state=="Florida")
   {
   }
//
// handling for Georgia coding
//
   if (state=="Georgia")
   {
   }
//
// handling for Hawaii coding
//
   if (state=="Hawaii")
   {
   }
//
// handling for Idaho coding
//
   if (state=="Idaho")
   {
   }
//
// handling for Illinois coding
//
   if (state=="Illinois")
   {
   }
//
// handling for Indiana coding
//
   if (state=="Indiana")
   {
   }
//
// handling for Iowa coding
//
   if (state=="Iowa")
   {
   }
//
// handling for Kansas coding
//
   if (state=="Kansas")
   {
   }
//
// handling for Kentucky coding
//
   if (state=="Kentucky")
   {
   }
//
// handling for Louisiana coding
//
   if (state=="Louisiana")
   {
   }
//
// handling for Maine coding
//
   if (state=="Maine")
   {
   }
//
// handling for Maryland coding
//
   if (state=="Maryland")
   {
   }
//
// handling for Massachusetts coding
//
   if (state=="Massachusetts")
   {
   }
//
// handling for Michigan coding
//
   if (state=="Michigan")
   {
   }
//
// handling for Minnesota coding
//
   if (state=="Minnesota")
   {
   }
//
// handling for Mississippi coding
//
   if (state=="Mississippi")
   {
   }
//
// handling for Missouri coding
//
   if (state=="Missouri")
   {
   }
//
// handling for Montana coding
//
   if (state=="Montana")
   {
   }
//
// handling for Nebraska coding
//
   if (state=="Nebraska")
   {
   }
//
// handling for Nevada coding
//
   if (state=="Nevada")
   {
   }
//
// handling for NewHampshire coding
//
   if (state=="NewHampshire")
   {
   }
//
// handling for NewJersey coding
//
   if (state=="NewJersey")
   {
   }
//
// handling for NewMexico coding
//
   if (state=="NewMexico")
   {
   }
//
// handling for NewYork coding
//
   if (state=="NewYork")
   {
   }
//
// handling for NorthCarolina coding
//
   if (state=="NorthCarolina")
   {
   }
//
// handling for NorthDakota coding
//
   if (state=="NorthDakota")
   {
   }
//
// handling for Ohio coding
//
   if (state=="Ohio")
   {
   }
//
// handling for Oklahoma coding
//
   if (state=="Oklahoma")
   {
   }
//
// handling for Oregon coding
//
   if (state=="Oregon")
   {
   }
//
// handling for Pennsylvania coding
//
   if (state=="Pennsylvania")
   {
   }
//
// handling for PuertoRico coding
//
   if (state=="PuertoRico")
   {
   }
//
// handling for RhodeIsland coding
//
   if (state=="RhodeIsland")
   {
   }
//
// handling for SouthCarolina coding
//
   if (state=="SouthCarolina")
   {
   }
//
// handling for SouthDakota coding
//
   if (state=="SouthDakota")
   {
   }
//
// handling for Tennessee coding
//
   if (state=="Tennessee")
   {
   }
//
// handling for Texas coding
//
   if (state=="Texas")
   {
   }
//
// handling for Utah coding
//
   if (state=="Utah")
   {
   }
//
// handling for Vermont coding
//
   if (state=="Vermont")
   {
   }
//
// handling for Virginia coding
//
   if (state=="Virginia")
   {
   }
//
// handling for Washington coding
//
   if (state=="Washington")
   {
   }
//
// handling for WestVirginia coding
//
   if (state=="WestVirginia")
   {
   }
//
// handling for Wisconsin coding
//
   if (state=="Wisconsin")
   {
   }
//
// handling for Wyoming coding
//
   if (state=="Wyoming")
   {
   }
//
// all state entries should return clerror[6] as "Fail" to reject link
//
   if (clerror[6]=="Fail")
   {
      selinklog(slink, olink, dircode, 6, "S");
      return null;
   }
   return olink;
}