function createGeoDB(jsfile,db,addprop)
//
// this function reads in a geojson file, provides link and node indices and writes it out as a Feature class array
//
{
   if (batchflag && dbtrace) WScript.Echo ("Entering CreateGeoDB");   
//
   var link=1;
   var anode=1;
   var bnode=2;
   var importerr=true;
   var init=true;
   var geoerrors=0;
   var reccnt=0;  
   var input=fso.OpenTextFile(jsfile,1);
   while (!input.AtEndofStream)
   {
      var rec=input.readLine();
      reccnt++;
//
// update feature record as needed (use ANODE to flag any previous updates)
//
      if (rec.indexOf("ANODE")<0) 
      {
/*         var bpoint=rec.indexOf("ture\", ")+7;
         rec=rec.slice(0,bpoint)+"\"ID\":"+link.toString()+",\"APOS\":,\"BPOS\":,\"LEXT\":,\"HEXT\":,"+rec.slice(bpoint);
//
// add ANODE, BNODE to all files
//
         bpoint=rec.indexOf("ties\": {")+8;
   rec=rec.slice(0,bpoint)+"\"ANODE\": "+anode.toString()+",\"BNODE\": "+bnode.toString()+" ,"+rec.slice(bpoint); 
//
// use add properties string to apply default values to all new fields
//
*/         bpoint=rec.indexOf("\"geometry\"");
         bpoint=rec.substr(0,bpoint).lastIndexOf("}")-1;
         rec=rec.slice(0,bpoint)+addprop+rec.slice(bpoint);
//
// this code fixes import errors
//
         if (importerr) 
         {
            if (batchflag && dbtrace) WScript.Echo("object=" + rec + ";");
            var tmpobj=JSON.parse(rec);
            var inrec=JSON.stringify(tmpobj);
            rec=fixImport(inrec);
            if (inrec==rec && init) importerr=false;
            init=false;
         }
      }
      if (rec!=null)
      {
         rec=JSON.parse(rec);
         if (rec.properties.F_SYSTEM<9)
         {
            db[link]=rec;
//
// copy anode/bnode positions to base attributes (GeoJSON nonstandard/clean up before serialization)
//
            db[link].ID=link;
            db[link].properties.INDEX=link;
            db[link].properties.ANODE=anode;
            db[link].properties.BNODE=bnode;
            db[link].APOS=db[link].geometry.coordinates[0];
            db[link].BPOS=db[link].geometry.coordinates[db[link].geometry.coordinates.length-1];
            var box=turf.bbox(db[link]);
            db[link].LEXT=[box[0],box[1]]
            db[link].HEXT=[box[2],box[3]]
//
// initialize start/end transaction records for target database
//
            if (jsfile==targetf)
            {
               db[link].properties.AB_LINKERR=null;
               db[link].properties.BA_LINKERR=null;
            }
            link++;
            anode=anode+2;
            bnode=bnode+2;
         }
      }
      else
      {
         geoerrors++;
         reportWrite("(Warning) Record # "+reccnt.toString()+" is 0 length (no geography defined) ... Skipping");
      }
   }
   if (geoerrors) reportWrite("(Warning) "+geoerrors.toString()+" 0 length (no geography defined) records discarded");
   return link;
}