function reportWrite (text,noprint,start)
// 
// support function to handle both report and page writing for LinkerAT
// "start" resets file for summary output
{
   if (noprint==null) noprint=false;
   if (noprint==false)
   {
      var openmode=8;
      if (report_file==null) openmode=2;
      report_file=fso.OpenTextFile(reportf,openmode,true);
      report_file.WriteLine(text);
      report_file.Close();
   } 
//
// always write to log report  
//
   if (noprint) 
   {
      var openmode=8;
      if (summary_file==null) openmode=2;
      summary_file=fso.OpenTextFile(summaryf,openmode,true);
      summary_file.WriteLine(text);
      summary_file.Close();
   }
   return;
}
   
function chainWrite (chain)
// 
// support function to handle both report and page writing for LinkerAT
//
{
   var openmode=8;
   if (chain_file==null) openmode=2;
   chain_file=fso.OpenTextFile(chainf,openmode,true);
   chain_file.WriteLine(chain);
   chain_file.Close();
   return;
}

function statWrite(noprint)
//
// this function writes the formatted exception summary with current values. 
// noprint inhibits reporting for summary only entries (supports real time updating of display)
//
{ 
   reportWrite("EXCEPTION SUMMARY FOR SOURCE ROUTES\n\n",noprint,true);
   reportWrite(excepts[1].toString()+" exceptions-No usable start link found (Link skipped)\n",noprint);
   reportWrite(excepts[2].toString()+" exceptions-No usable end link found (Partial chain written)\n",noprint);
   reportWrite(excepts[3].toString()+" exceptions-No connectable middle link found (Partial chain written)\n",noprint);
   reportWrite(excepts[4].toString()+" exceptions-Circular Target links (Partial chain written)\n",noprint);
   reportWrite(excepts[5].toString()+" exceptions-Start/end nodes are same value (Link ignored)\n",noprint);
   reportWrite(excepts[6].toString()+" exceptions-No tracable path to end link (Link ignored)\n\n",noprint);
   reportWrite("End EXCEPTION SUMMARY FOR SOURCE ROUTES",noprint);
   return;
}
//
// page refresh timeout
//
function pagerefresh(loc)
{
   loc.location.reload();
}
