function getEndLink(targett,node,sname,slink,start,reverse)
//
// this routine searches for corresponding links to a source layer node in a target layer
// it returns an array of candidates that can be used to stop a path search. if the buffer 
// search fails, the routine looks for links that meet proximity criteria. Flag start indicates
// whether this an start link or exit link search. Reverse searches treat end link as start link
// to identify CORRIDOR_ID during revisit
//
// use adjusted distance accounting for link to link distance to find matchable nodes
//
{
   clerrors=new Array();
   var nchgupd=false;        //use to control branching out of function or restart loop
   var elrestart=true;        //same as above
//
// target in this case refers to ARNOLD
//
   var addbuf=buffer*2.5;
   var addist=disttol;
   if (start && targett) 
   {
      addbuf=buffac*addbuf;   //relax buffer size constraint on start links if CORRIDOR_ID is given
   }
   var link=[null,null,null]; //start link, end link, bnode (for connecting)
   if (!start) 
   {
      lktype="END";
      exit=true;
   }
   else
   {
      lktype="START";
      exit=false;
   }
//
// get candidate links - with usable nodes (assumes flow and topological dir in source map are the same - one way links)
//
   var coord=getPoint(node,slink,tlinks);
   var bn=getBNode(node,slink,tlinks);
   var endcoord=getPoint(bn[0],slink,tlinks);
//   if (reverse) coord=endcoord;
restart:
   while (link[0]==null && elrestart)
   {
      elrestart=false;
      clinks=findNearestLinks(alinks,turf.point(coord),addbuf);
      if (clinks[0]==null) 
      {
         reportWrite("(Warning) No nearby target "+lktype+" links identified link for source link "+slink.toString()+" - probable overshoot");
         return link;
      }
//
// build distance sorted list of candidate nodes
//
      var cnodes=new Array();
      for (var i=0;i<clinks.length;i++)
      {
         var an=alinks[clinks[i][0]].properties.ANODE;
         var ap=alinks[clinks[i][0]].APOS;
         var bn=alinks[clinks[i][0]].properties.BNODE;
         var bp=alinks[clinks[i][0]].BPOS;
//
// distances are to source start node for start links and source end node for end links (both use coord value)  
//
         var ao=turf.distance(coord,ap,{units: 'miles'});
         var bo=turf.distance(coord,bp,{units: 'miles'});
//
// get shortest "endcoord distance for link sort
//
         var endao=turf.distance(endcoord,ap,{units: 'miles'}); 
         var endbo=turf.distance(endcoord,bp,{units: 'miles'}); 
         if (endao<endbo) var edist=endao;
         else var edist=endbo;

// this code builds the sort keys for start/end links looking at node proximity, likelihood of similar allignment and
// link proximity in that order
//
//
// use bn locations to identify likely start link with multiple candidates
// relative distance comparing further away node to nearer node provides an "exposure index" indicating likelhood of 
// parallel alignments between source and candidate target link. because we don't know here if a link represents two way
// flow, candidate descriptions are built for both flow directions. CheckAngles qualifies the candidate for flow dir and
// continues processing the list if criteria are not met
// 
//
// create "flow direction" candidates
//
         var adiff=endao-endbo;
         cnodes.push([clinks[i][1],an,clinks[i][0],"A",ao,adiff,edist]);
         cnodes.push([clinks[i][1],bn,clinks[i][0],"B",bo,-adiff,edist]);
      }
//
// sort by keys (exposure index:shortest distance to source b-node)
//
      cnodes=cnodes.sort(function(a,b) {return b[5]-a[5]||a[6]-b[6]});
//
      clerrors=new Array(cnodes.length);
//
// get node nearest tme anode
//
      var cnodesidx=0;
     clerror=["Not Used","Not Used","Not Used","Not Used","Not Used","Not Used"];
     while (link[0]==null && cnodesidx<cnodes.length) 
     {
//
// looking for start link - rely on geometry (semantic checks can be added here)
//
         clerror[0]=cnodes[cnodesidx][2].toString()+"/"+cnodes[cnodesidx][1].toString();
         var vtest=alinks[cnodes[cnodesidx][2]].properties.VISIT;
         clerror[3]="Fail";
         if (vtest.indexOf(cnodes[cnodesidx][3])==-1) 
         {
            clerror[3]="Pass"; 
            if (!exit) 
            {
               link[0]=checkAngles(alinks,cnodes[cnodesidx][1],cnodes[cnodesidx][2],tlinks,node,slink,reverse,cnodes[cnodesidx][3]);
               if (cnodes[cnodesidx][0]>addist && link[0]!=null) 
               {
                  clerror[1]="Pass";
                  clerror[2]="Fail";
                  selinklog(slink, cnodes[cnodesidx][2], cnodes[cnodesidx][3], 2, "S");
                  link[0]=null;
               }
               if (link[0]==null) 
               {
                  selinklog(slink, cnodes[cnodesidx][2], cnodes[cnodesidx][3], 1, "S");
                  clerror[1]="Fail";
               }
               clerror[2]="Pass";
//
// if xref available, check for match on identifier
//
               if (targett!=null && link[0]!=null) 
               {
                  clerror[4]="Fail"; 
                  if (targett!=alinks[link[0]].properties.CORRIDOR_ID) 
                  {
                     selinklog(slink, cnodes[cnodesidx][2], cnodes[cnodesidx][3], 4, "S");
                     link[0]=null;
                  }
                  else clerror[4]="Pass"
               }

               if (link[0]!=null)
               {
                  link[1]=alinks[link[0]].properties.CORRIDOR_ID;
                  bn=getBNode(cnodes[cnodesidx][1],link[0],alinks);
                  link[2]=bn[0];
                  break restart;
               }
            }
            else 
//
// looking for end link - use start link profile to match - apply disttol to candidate node 
// 
            {
               if (cnodes[cnodesidx][0]>disttol) 
               {
                  clerror[2]="Fail";
                  selinklog(slink, cnodes[cnodesidx][2], cnodes[cnodesidx][3], 2, "E");
               }
               else 
               {
                  clerror[4]="Fail";
                  if (targett==alinks[cnodes[cnodesidx][2]].properties.CORRIDOR_ID) 
                  {
                     if (link[0]==null) 
                     {
                        link[0]=cnodes[cnodesidx][2];
                        var bn=getBNode(cnodes[cnodesidx][1],link[0],alinks);
                        link[2]=bn[0];
                        clerror[4]="Pass";
                     }
                     else if (link[1]=null) link[1]=cnodes[cnodesidx][2];
                     if (link[0]!=null && link[1]!=null) break restart;
                  }
                  else selinklog(slink, cnodes[cnodesidx][2], cnodes[cnodesidx][4], 4, "E");

               }
            }
         }
         else 
         {
            clerror[3]="Fail";
            selinklog(slink, cnodes[cnodesidx][2], cnodes[cnodesidx][3], 3, "E");
         }
         if (cnodesidx < cnodes.length) clerrors[cnodesidx]=clerror.slice();
         cnodesidx=cnodesidx+1;
      }
//
// this code evaluates link structure and splits links (adds nodes) to create logical start/end links
//
newnode:
      if (link[0]==null && !nchgupd) 
      {
//
// get shape point based angles for nearest links
//
         var clink=new Array(3);
         for (i=0;i<clinks.length;i++)
         { 
//          if (slink==tracelink) then ShowMessage("Checking ... L="+string(clinks[i])+" D="+string(cdist[i][1]))
            if (clinks[i][1]<addbuf) 
            {
               if (! exit) 
               {
                  var an=alinks[clinks[i][0]].properties.ANODE;
                  var bn=alinks[clinks[i][0]].properties.BNODE;
//
// conditionally use both ends of link to test relative offset to TMC
//
                  var alink=checkAngles(alinks,an,clinks[i][0],tlinks,node,slink);
                  var clink=[alink,alink,an,"A"];
                  if (clink[0]==null) 
                  {
                     var blink=checkAngles(alinks,bn,clinks[i][0],tlinks,node,slink);
                     clink=[blink,blink,bn,"B"]; 
                  }
               }
//
// for candidate exits, match start link identifier (clink[1] and [3] are placeholders
//
               if (targett) 
               {
                  var vtest=alinks[clinks[i][0]].properties.VISIT;
                  if (targett==alinks[clinks[i][0]].properties.CORRIDOR_ID &&
                      vtest.indexOf(cnodes[i][3])==-1) clink=[clinks[i][0],clinks[i][0],cnodes[i][1]];
                  else clink[0]=null;
               }
//
// if angles are tolerant and nodes within distance tolerance for snap, split link and update segments
//
               if (clink[0]!=null) 
               {
                  clerror[5]="Pass";
//
// on "to" split, slink must be reidentified due to reindexing for "to" links 
//
                  if (exit) 
                  {
                     if (clink[0]==slinka[0]) nchgupd=true;
                  }
//
// check for three types of link split. 1) anode of start link 2. bnode of start link 3. bnode of end link
// for the last two similar conditions must be met. 
//
                  var rc=splitLink(alinks,coord,clink[1],exit,"A");
                  if (rc==5)
                  {
                     link[0]=null
                     clerror[5]="Fail"
                     selinklog(slink, clink[1], "A", 5, "E");
                     return link;
                  }
//
// for bnode, test length offset for both start and end links (the test is against the link just added to the object stack)
//
                  bn=getBNode(alinks[alinks.length-1].properties.ANODE,alinks.length-1,alinks);
                  if (bn[1]=="AB") alcoord=alinks[alinks.length-1].BPOS;
                  else alcoord=alinks[alinks.length-1].APOS;
                  if (checkEndPoint(tlinks,alcoord,slink)) 
                     var rc=splitLink(alinks,endcoord,alinks.length-1,exit,"B");
                  if (rc===5)
                  {
                     link[0]=null
                     clerror[5]="Fail"
                     selinklog(slink, clink[1], "B", 5, "E");
                     return link;
                  }
                  nchgupd=true;
                  elrestart=true;
                  newnodect=newnodect++;
//
// after link split is done, branch back for reroute call
//
                  if (exit && slinka[0]==null) return [-99,0,0];
                  continue restart;
               }
            }
         }
      }
   }
   return link;
}
