function getTargetRoute(tnode,tlink,anode,alink)
//
// this routine mananges walking the link tree 
// TMC links seed the ARNOLD search process
// values passed are used in matching the two networks links
//
// get TMC start and end node link references
//
{
   locate=new Array(2);
   var start_tnode=tnode;
   if (tnode==null) return null;
   var l=getBNode(tnode,tlink,tlinks);var end_tnode=l[0];var tlink_AB=l[1];
   var end_tcoord=getPoint(end_tnode,tlink,tlinks);
//
// build xref field for TMC/ARNOLD links passed
//
   var tname=tlinks[tlink].properties.ROADNUMBER+"|"+
         tlinks[tlink].properties.ROADNAME+"|"+
         tlinks[tlink].properties.DIRECTION+"|"+
         tlinks[tlink].properties.F_SYSTEM.toString();
   var tid=tlinks[tlink].properties.TMC;
//
// this only applies to seeds - tack it on. if it's already there it doesn't matter
//
   if (alink!=null) 
   {
      var aname=alinks[alink].properties.CORRIDOR_ID;
      l=getBNode(anode,alink,alinks);bnode=l[0];
      slinka=[alink,aname,bnode];
   }
//
// logic to identify corrsponding route name for ARNOLD
//
   else 
   {
      aname=null;    
//
// search xref table 
//
      if (xID[0].indexOf(tname)!=-1) aname=xID[1][xID[0].indexOf(tname)]; 
   }
//
// no previous reference for ARNOLD start link, use semantic/geolocation criteria search
// nchgupd provides for resetting start/end link def if topology is updated
//
   nchgupd=true;
linkloop:
   while (nchgupd) 
   {
      nchgupd=false;
//
// trace operation call
//
      if (tlink==tracelink) 
      {
         showInfo ("!Starting Link "+tlink.toString()+" Chain!");
      }
      var rc=1;  //return code initialized to "success"
//
// wrap slink build in exit call for single segment genration (a & b nodes modified)
//
      var inlength=alinks.length;
      if (alink==null) slinka=getEndLink(aname,start_tnode,tname,tlink,true);
//
// if using xID reference and no link, try it without
//
      if (slinka[0]==null && aname) slinka=getEndLink(null,start_tnode,tname,tlink,true);
//
// if no link found, move to to next TMC
//
      if (slinka[0]==null) 
      {
         reportWrite("(Warning) No start link found for source link "+tlink.toString()+" skipping...");
         linkSearchSummary(clerrors);
         updateExceptions(-1);
         return -1;
      }
      aname=slinka[1];
//
// use returned end node to get start node and indirectly start link topology
//
      var l=getBNode(slinka[2],slinka[0],alinks); var nodetemp=l[0];var alinkflag=l[1]; 
      var l=getBNode(nodetemp,slinka[0],alinks); var nodetemp=l[0];var alinkflag=l[1]; 
      selinklog(tlink, slinka[0], alinkflag.substring(0,1), 0, "S");      
      if (test_index==tlink) 
      {
         reportWrite("(Debug) Starting chain for "+aname+" on Link "+slinka[0].toString()+" at Node "+slinka[2].toString());
      }
//
// handles single link with both ends modified
//
      if (alinks.length-inlength>1)
      {
         elinka[0]=slinka[0];
         break linkloop;
      }
//
// get far end link the same way 
//
      elinka=getEndLink(aname,end_tnode,tname,tlink,false);
      if (elinka[0]==null && !nchgupd) 
      {
         reportWrite("(Warning) No end link found for source link "+tlink.toString()+" processing start node only...");
         linkSearchSummary(clerrors);
         updateExceptions(-2);
         var rc=-2;
      }
//
// if tour start node and tour end node are the same, this is a 0 distance reference and can't be a xref
//
      else
      {
         if (end_tnode==elinka[2]) 
         {
            reportWrite("(Warning) Source ["+tname+"] has same start/end target nodes ("+
            end_tnode.toString()+") and link ("+tlink.toString()+" )  in target - TMC link ignored");
            updateExceptions(-5);
            return -5;
         }
         var l=getBNode(elinka[2],elinka[0],alinks); var nodetemp=l[0];var alinkflag=l[1]; 
         selinklog(elinka[0], tlink, alinkflag.substring(0,1), 0, "E");      
      } 
   }
//   
   if (test_index==tlink) 
   {
      reportWrite("(Debug) Ending chain for "+aname+" on Link "+elinka[0].toString()+" at Node "+elinka[2].toString());
   } 
//
// got start and end (far) links for route, compile intermediate segments 
//
   slink=slinka[0];
   elink=elinka[0];
   snode=slinka[2];
//
// trace route using Corridor_ID to filter links
//
   var mlcnt=0;
   var lchkcnt=0;
   var chaini=new Array(slink,slink);
   chaini.pop();
   var achain="";
   var chainab=new Array(alinkflag,alinkflag);
   chainab.pop();
   var chainct=2;
   var rteerror=false;
//
// loop till end of exit list or error (write partial chain after error)
//
writechain:
   while (slink!=elinka[0] && slink!=elinka[1] && lchkcnt<500 && !IsEndNode(end_tcoord,alinks,slink,snode) && !rteerror) 
   {
      var l=getBNode(snode,slink,alinks);bnode=l[0];flag=l[1];
      exits=getExits(snode,slink,alinks);
      exfound=false;
      for (var i=0;i<exits.length;i++) 
      {
         if (! exfound)
         {
            if (alinks[exits[i][0]].properties.CORRIDOR_ID==aname) 
            {
               exfound=true;
               slink=exits[i][0];
               var l=getBNode(exits[i][1],slink,alinks);snode=l[0];flag=l[1];
//
// check for circular references
//
               for (var j=1;j<chaini.length;j++)
               {
                  if (slink==chaini[j]) 
                  {
                     reportWrite("(Warning) Circular reference for link/node "+slink.toString()+"/"+snode.toString()+" write partial chain source link "+tlink.toString());
                     updateExceptions(-4);
                     rc=-4;
                     break writechain;
                  }
               }
               mlcnt=mlcnt+1;
               achain=achain+alinks[exits[i][0]].properties.LINKID+"("+slink.toString()+"),";
               chaini.push(slink);
               chainab.push(flag);
               chainct=chainct+1;
               if (test_index==tlink) 
               {
                  reportWrite("(Debug) Adding to chain for "+aname+" with Link "+slink.toString()+" ending at Node "+snode.toString());
               }
               continue writechain;
            } 
         }
         
      }
      if (! exfound) 
      {
         reportWrite("(Warning) No exits found for middle link/node "+slink.toString()+"/"+snode.toString()+" write partial chain source link "+tlink.toString());
         updateExceptions(-3);
         rc=-3
         break writechain;
      }
   }
   if (chaini.length>=500) 
   {
      rpchain=achain.substr(0,120)+"...";
      reportWrite("(Warning) For source link "+tlink.toString()+ "\n          Chain exceeds 500 links - abandoning search...");
      reportWrite("          First 120 characters - "+rpchain); 
      updateExceptions(-6);
      return -6;
   }
//
// write PATHSEGs for chain, near and far segments
//
// "break writechain"
//
// retrace chain
//
   achain=tid+"("+tlink.toString()+"),"+alinks[slinka[0]].properties.LINKID+"("+slinka[0].toString()+"),"+achain;
   for (var i=0;i<chaini.length;i++)
   {
      eval("alinks[chaini[i]].properties."+chainab[i]+"_PATHSEG=\""+tid+"|"+i.toString()+"|\"");
      if (alinks[chaini[i]].properties.VISIT=="N") alinks[chaini[i]].properties.VISIT=chainab[i].substr(0,1);
      else alinks[chaini[i]].properties.VISIT="AB";  
   }
//
// update xref ID and visit field
//
   if (xID[0].indexOf(tname)>-1) xID[1][xID[0].indexOf(tname)]=aname;
   else
   {
      xID[0].push(tname);
      xID[1][xID[0].indexOf(tname)]=aname; 
   }
//
// write end segment if not single link chain
// 
   if (slinka[0]!=slink) 
   { 
      eval("alinks[slink].properties."+flag+"_PATHSEG=\""+tid+"|"+mlcnt.toString()+"|\"");
   }
   chainWrite(achain);
   if (rc>0) 
   {
      reportWrite("(Information) Full link chain for "+tid+"("+tlink.toString()+") complete - "+chaini.length.toString()+" link(s) found");
      if (tlinks[tlink].properties.VISIT<0) updateExceptions(Math.abs(tlinks[tlink].properties.VISIT));
      tlinks[tlink].properties.VISIT=1;
   }
   else reportWrite("(Information) Partial link chain for "+tid+"("+tlink.toString()+") written - "+chaini.length.toString()+" link(s) found");
//
// use link chain information to write mirror chain for two way links 
//
// this structure allows insert for state specific criteria
//
   if (check2WayFlow(chaini[chaini.length-1],alinks)) rtlink=SourceRVisit(tlinks,tlink,tlinks[tlink].properties.TMC);
   else rtlink=0;
//
// reverse link handler
//
   if (rtlink>0) 
   {
      rtid=tlinks[rtlink].properties.TMC;
      rtname=String(tlinks[rtlink].properties.ROADNUMBER)+"|";
      rtname=rtname+tlinks[rtlink].properties.ROADNAME+"|";
      rtname=rtname+tlinks[rtlink].properties.DIRECTION+"|";
      rtname=rtname+String(tlinks[rtlink].properties.F_SYSTEM);
      j=1
      rchain="";
      for (var i=chaini.length-1;i>=0;i--)
      {
         if (alinks[chaini[i]].properties.AB_PATHSEG != null)
         {
            alinks[chaini[i]].properties.BA_PATHSEG=rtid+"|"+j.toString()+"|";
            alinkflag="BA";
         }
         else 
         {
            alinks[chaini[i]].properties.AB_PATHSEG=rtid+"|"+j.toString()+"|";
            alinkflag="AB";
         }
         rchain=alinks[chaini[i]].properties.LINKID+"("+chaini[i].toString()+"),";
         if (alinks[chaini[i]].properties.VISIT="N") alinks[chaini[i]].properties.VISIT=alinkflag.substr(0,1);
         else alinks[chaini[i]].properties.VISIT="AB";
         j++;
      }
      tlinks[rtlink].properties.VISIT=1;
      rchain=rtid+"("+rtlink.toString()+"),"+rchain;
      chainWrite(rchain);
      reportWrite("(Information) Reverse Link chain for "+rtid+"("+rtlink.toString()+") written - "+chaini.length.toString()+" link(s) found");
      if (xID[0].indexOf(rtname)>-1) xID[1][xID[0].indexOf(rtname)]=aname; 
      else
      {
         xID[0].push(rtname);
         xID[1][xID[0].indexOf(rtname)]=aname; 
      }
   }
   return elink; 
}
