function initialize()
//
// this function supports the GeoJson version of LinkAT's creation of the program data model including opening
// and reading in all necessary inputs to support the program
//
{
   if (batchflag && dbtrace) WScript.Echo ("Entering Initialize");   
//
// construct file paths based on settings
//
// state specific file inputs
//
   if (state=="Colorado")
   {
      routenmf=root+"\\"+rootf+"\\"+state+"\\"+year+"\\Resources\\RouteNames.csv"; //currently only for CO
   }
//
// create target chain file
//
      chainWrite(sourcedf+" ID,N Count "+targetdf+" Links [ESRI_OID]/(Link Index)");
//
// if available, read preexisting cross reference table
//
   if (fso.fileExists(xidf)) 
   {
      xidtable=fso.OpenTextFile(xidf,1);
      var i=0;
      var ids;
      while (!xidtable.AtEndOfStream) 
      {
          ids=xidtable.ReadLine().split(",");
          xID[0].push(ids[0]);
          xID[1].push(ids[1]);
          i++;
      }  
      reportWrite ("(Information): "+String(xID[0].length)+" route cross references read from "+xidf+"\n");
   }
//
// initialize source and target network features (modify and parse incoming geoJSONS) 
//
   var scount=createGeoDB(sourcef,tlinks,", \"VISIT\": 0");
   reportWrite("\n(Information) ["+sourcef+"] GEOJSON Object Successfully Created ("+scount.toString()+" links)\n");
   var tcount=createGeoDB(targetf,alinks,", \"CORRIDOR_ID\": null, \"ALT_ID\": null, \"AB_PATHSEG\": null, \"BA_PATHSEG\": null, \"LINKID\": null, \"AB_LINKERR\": null, \"BA_LINKERR\": null, \"VISIT\": \"N\"");
   reportWrite("\n(Information) ["+targetf+"] GEOJSON Object Successfully Created ("+tcount.toString()+" links)\n");
   if (tpvalidate) alignTDirToFDir(alinks);
//
// build "corridor ID" and "LINKID" for target if not in input
//
   if (CIDReload) 
   {
      reportWrite("\n(Information) Reloading CORRIDOR ID from "+state+" Handler\n");
      fillCorridorID(alinks)
   }
   else reportWrite("\n(Information) ["+targetbf+"] Reusing saved CORRIDOR IDs\n");
//
// write inital output for checking (reinstate as option)
//
   if (baseSave)
   {
      updateGeoDB(tlinks,sourcebf)
      reportWrite("\n(Information) ["+sourcebf+"] Updated GEOJSON Object Successfully Serialized\n");
      updateGeoDB(alinks,targetbf)
      reportWrite("\n(Information) ["+targetbf+"] Updated GEOJSON Object Successfully Serialized\n");
   }
//
//initialize "visit" in both source and target dbs
//
   for (i=1;i<tlinks.length;i++)
   {
      if (!returntrip) tlinks[i].properties.VISIT=0;
   }
   for (i=1;i<alinks.length;i++)
   {
      if (!returntrip) alinks[i].properties.VISIT="N";
   }
//   FilterSet(aview,avisit,"F_SYSTEM")
   avisits=0
//
// build link to node pair lookup array (superceded by object structure)
//
/*   SetLayer(tview)
   nodeprs=CopyArray(tvisit)
   for i=1 to nodeprs.length do
      if (nodeprs[i]<>null) then do
         ab=GetEndpoints(i)
         nodeprs[i]=String(ab[1])+"|"+string(ab[2])
      end
   end 
*/
//
// build link to TMC identifier lookup array (superceded by object structure) 
//
   for (var i=1;i<tlinks.length;i++)
   {
      tmctable[i]=tlinks[i].properties.TMC;
   } 
   return;
}
