function copyArray(object)
//
// uses stringify and parse to clone array or object
//
{
   var string=JSON.stringify(object);
   return JSON.parse(string);
}
function fixImport(rec)
//
// corrects potential errors in externally generated JSON records. Called from CreateGeoDB.
// set up to fix property names (should be all uppercase) and use of multi line strings in geometry
// since all records are structured the same, first record provides guidance to bypass after initial
//
{
   var pobject=JSON.parse(rec);
//
// flatten and stringify if MultiLineString
//
   if (pobject.geometry.type=="MultiLineString")
   {
      var tmpobj=turf.flatten(pobject);
      rec=JSON.stringify(tmpobj.features[0]);   
   }
//
// handles property name changes
//
   var pnarray=Object.keys(pobject.properties);
   for (var i=0;i<pnarray.length;i++)
   {
      if (pnarray[i]!=pnarray[i].toUpperCase())
      {
         if (!rec) return null; 
         rec=rec.replace("\""+pnarray[i]+"\"","\""+pnarray[i].toUpperCase()+"\"");
      }
   }
//
// converts "MultiLineString" type to "LineString" type (assumes geometry is unique in type)
//
   return rec;
}