function revisit()
//
// conducts postprocessing of unsatisfied visits using end link search to identify start link name
//
// unresolved visit postprocessing - use "unvisited list to select
//
{
   var ppvisits=0;
   if (excepts[1]>0) reportWrite("\n(Information) Revisiting "+excepts[1].toString()+" source links without target start links");
   for (var svisit=restart;svisit<tlinks.length;svisit++)
   { 
//      reportWrite ("svisit="+svisit.toString());    
      if (tlinks[svisit].properties.VISIT==-1) 
      {
         reportWrite("\n(Information) Reverse tracing source link "+tmctable[svisit]+"("+svisit.toString()+")\n");
         var link=getEndLink(null,tlinks[svisit].properties.BNODE,tlinks[svisit].properties.CORRIDOR_ID,svisit,true,true);
         if (link[0]==null) reportWrite("(Information) No traceable link found for "+tmctable[svisit]+"("+svisit.toString()+")\n");
         else
         {
            foundnext=true;
            sdist=turf.length(tlinks[svisit],{units: 'miles'});
            nextl=link[0];
            aname=link[1];
            lastl=-1;
//
// use node-to-node distance from link a and b to start of source link to determine which node
//
            var scoord=getPoint(tlinks[svisit].properties.ANODE,svisit,tlinks);    
            var ad=turf.distance(scoord,alinks[nextl].APOS,{units: 'miles'});
            var bd=turf.distance(scoord,alinks[nextl].BPOS,{units: 'miles'});
            if (ad<bd) nextn=alinks[nextl].properties.ANODE;
            else nextn=alinks[nextl].properties.BNODE;
            while (foundnext)
            {
               var entries=getExits(nextn,nextl,alinks,true) //actually getEntries but function is same
               enfound=false;
               var targdist=0;
               setlastl=false;
               for (var i=0;i<entries.length;i++)
               {
                  if (entries[i][0]==lastl) setlastl=true;
                  if (! enfound && !setlastl)
                  {
                     if (alinks[entries[i][0]].properties.CORRIDOR_ID==aname)
                     {
                        enfound=true;
                        setlastl=false;
                        targdist=targdist+turf.length(alinks[entries[i][0]],{units: 'miles'});
//
// test against where we are in relation for start node of source link - either continue chain or stop if past
//
                        if (targdist>sdist+maxsnap)
                        {
                           targdist=targdist-turf.length(alinks[entries[i][0]],{units: 'miles'});
                           foundnext=false;
                        }
                        else
                        {
                           lastl=nextl;
                           nextl=entries[i][0];
                           var ad=turf.distance(scoord,alinks[nextl].APOS,{units: 'miles'});
                           var bd=turf.distance(scoord,alinks[nextl].BPOS,{units: 'miles'});
                           if (ad<bd) nextn=alinks[nextl].properties.ANODE;
                           else nextn=alinks[nextl].properties.BNODE;
                        }
                     }
                  }
               }    
               if (! enfound) foundnext=false;
            }
//
// this handles running past the last usable link
//
            if (setlastl) 
            {
               nextl=lastl;
//               bn=getBNode(nextn,nextl,alinks);nextn=bn[0];
            }
            code=getTargetRoute(tlinks[svisit].properties.ANODE,svisit,nextn,nextl);
            tlinks[svisit].properties.VISIT=code;
            if (code>0) 
            {
               updateExceptions(1);
            }
         }
      }
   }
   return;
}
