function selinklog (linkt, linka, dir, errcode, otype)
//
// this function writes codes to the LINKERR field in the output GeoJSON DB to record actions and results of applying
// the link to the start/end link selection algorithm. It provides an in-file description of that activity for easy 
// review when using a map application
//
// each time the link is queried by getEndLink a short message is added to the LINKERR field for that link.
// field format is: CCC(T)IL where CCC is one of the three character string below, T is S=start or E=end. IL is the index
// of the linput link being matched
//
//
{
   var errtype = new Array(8);
   var prefix;
   var field;
   var errstring;
//
// possible error types
//
   errtype[0]="SEI";      //start/end link identified successfully
   errtype[1]="ATL";      //beyond tolerance for input/output orientation angle match (Angle Too Large)
   errtype[2]="BSR";      //end nodes of output exceed search radius parameter (Beyond Search Radius)
   errtype[3]="FPV";      //link has already been used in a route (Found Previous Visit)
   errtype[4]="FCI";      //fails CORRIDOR_ID match - end links only (Fails Corridor ID)
   errtype[5]="CSL";      //node to break link can't be inserted (Can't Split Link)
   errtype[6]="SHF";      //rejected by state specific test (State Handler Failure)
   errtype[7]="RLO";      //link pointed toward source node not away (Reverse Link Orientation)
//
// check if link is used in a path
//
   if (alinks[linka].properties.VISIT.indexOf(dir)!=-1) return;
//
   if (dir="A") prefix="AB_";
   else prefix="BA_";
   field="alinks[linka].properties."+prefix+"LINKERR";
   errstring=errtype[errcode]+"("+otype+")"+linkt.toString()+"|";
//
// update field
//
   eval("if ("+field+"==null) "+field+"=\"|\";");
   eval(field+"="+field+"+\""+errstring+"\";");
   return;
}   