function splitLinkAttr(network,flink,tlink,inlinkid,ntype)
//
// used to adjust property values and extend feature array after a link split
// add blocks to custom manage attributes using JS eval to translate formulae
// handles correct updating of Visits based on ntype
{   
//
// populate link arrays with requried link properties values
//
   var ilinkp=network[inlinkid].properties;
   var flength=turf.length(flink, {units: 'miles'});
   var tlength=turf.length(tlink, {units: 'miles'});
   var llength=turf.length(network[inlinkid], {units: 'miles'});
   var index=network.length;
//
// Map original link properties to new links
//
   flink.properties=copyArray(ilinkp);
   tlink.properties=copyArray(ilinkp);
//
// MILEPOST REFERENCES - START
//
//
// calculate total mileage and get proportional start value
//
   if (ilinkp.END_POINT>ilinkp.BEGIN_POIN)   //A to B
   {
      flink.properties.END_POINT=flink.properties.BEGIN_POIN+flength;
      tlink.properties.BEGIN_POIN=flink.properties.END_POINT;
      tlink.properties.END_POINT=tlink.properties.BEGIN_POIN+tlength;
      tlink.properties.MEASURE=tlink.properties.BEGIN_POIN;
      tlink.properties.BNODE=ilinkp.BNODE;
      tlink.properties.ANODE=2*index-1;   
      flink.properties.BNODE=2*index;
   }
   else 
   {
      tlink.properties.END_POINT=tlink.properties.BEGIN_POIN+tlength;
      flink.properties.BEGIN_POIN=tlink.properties.END_POINT;
      flink.properties.END_POINT=flink.properties.BEGIN_POIN+flength;
      flink.properties.MEASURE=flink.properties.BEGIN_POIN;
      flink.properties.BNODE=ilinkp.BNODE;
      tlink.properties.ANODE=ilinkp.ANODE;
      tlink.properties.BNODE=2*index;   
      flink.properties.ANODE=2*index-1;
   }
//
// MILEPOST REFERENCES - END
//
// LINKID/INDEX/ANODE/BNODE Update - START
//
// LINKID identifies parsed segments - appends sequence to current LINKID
//
   flink.properties.LINKID=flink.properties.LINKID+"-1";
   tlink.properties.LINKID=tlink.properties.LINKID+"-2";
//
// LINKID - END
//
//
// VISIT FLAG
//
   if (ntype=="A")   //A to B
   {
      flink.properties.VISIT=ilinkp.VISIT;
      tlink.properties.VISIT="N";
   }
   else
   {
      flink.properties.VISIT="N";
      tlink.properties.VISIT=ilinkp.VISIT;
   }
//
// reset pos and extent for both links
//
      flink.APOS=flink.geometry.coordinates[0];
      flink.BPOS=flink.geometry.coordinates[flink.geometry.coordinates.length-1];
      var box=turf.bbox(flink);
      flink.LEXT=[box[0],box[1]]
      flink.HEXT=[box[2],box[3]]
      flink.properties.INDEX=inlinkid;
//
      tlink.APOS=tlink.geometry.coordinates[0];
      tlink.BPOS=tlink.geometry.coordinates[tlink.geometry.coordinates.length-1];
      var box=turf.bbox(tlink);
      tlink.LEXT=[box[0],box[1]]
      tlink.HEXT=[box[2],box[3]]
      tlink.properties.INDEX=index-1;
//
// update database with changes
// 
   network[inlinkid]=copyArray(flink);
   network[index]=copyArray(tlink);
   return;
}
