function checkAngles(olinks,onode,olink,ilinks,snode,slink,reverse)
//
// this routine calculates and compares exit angles for the links input. the calculation
// considers the assumed direction of the angle and adjusts for topology
// reserve flag handles "end of link" angles 
//
// first, get nodes/links in right order and find angles 
//
{
   if (reverse==null) reverse=false;
   var sb=getBNode(snode,slink,ilinks);
   var sp=ilinks[slink].geometry.coordinates;
   if (sb[1]=="AB") 
   { 
      var sloc=sp[1];
      if (!reverse) var sangle=turf.bearing(turf.point(sp[0]),turf.point(sp[1]));
      else var sangle=turf.bearing(turf.point(sp[1]),turf.point(sp[0]));
      if (sangle<0) sangle=sangle+360;
   }
   else
   {
      var sloc=sp[sp.length-1];
      if (!reverse) var sangle=turf.bearing(turf.point(sp[sp.length-1]),turf.point(sp[sp.length-2]));
      else var sangle=turf.bearing(turf.point(sp[sp.length-2]),turf.point(sp[sp.length-1]));
      if (sangle<0) sangle=sangle+360;
   }
//   
   var tb=getBNode(onode,olink,olinks);
   tp=copyArray(olinks[olink].geometry.coordinates);
   var tpl=tp.length;
//
// use point list to find nearest points to source point location
//
   for (var i=0;i<tpl;i++) tp[i]=[turf.distance(sloc,tp[i],{units: 'miles'}),tp[i],i];
   tp=tp.sort(function(a,b) {return a[0]-b[0]});
   if (!reverse) var tangle=turf.bearing(turf.point(tp[0][1]),turf.point(tp[1][1]));
   else var tangle=turf.bearing(turf.point(tp[tp.length-2][1]),turf.point(tp[tp.length-1][1]));
   if (tangle<0) tangle=tangle+360;
//
// after the sort, there can be four conditions to test for - two confirm tangle
//
   if (!reverse)
   {
      if (tp[0][2]<tp[1][2] && tb[1]=="BA") tangle=tangle+180%360;
      else if (tp[0][2]>tp[1][2] && tb[1]=="AB") tangle=tangle+180%360;
   }
   else
   {
      if (tp[tp.length-1][2]<tp[tp.length-2][2] && tb[1]=="BA") tangle=tangle+180%360;
      else if (tp[tp.length-2][2]>tp[tp.length-1][2] && tb[1]=="AB") tangle=tangle+180%360;
   }
   diffang=180-Math.abs(180-Math.abs(sangle-tangle));
   if (diffang>arctol) return null;
//
// start state specific rules criteria block
//
