function checkEndPoint(network,coord,inlinkid)
//
// this routine checks a given network link to see if the coordinate provided is beyond either end of
// inlinkid. This is used to identify when link splits if source links (start or end) are shorter than
// their target match link. where new nodes are not required (within distol), return false.
//
{
   var acoord=network[inlinkid].geometry.coordinates[0];
   var bcoord=network[inlinkid].geometry.coordinates[network[inlinkid].geometry.coordinates.length-1];
   var adist =turf.distance(turf.point(coord),turf.point(acoord),{units: 'miles'});
   var bdist =turf.distance(turf.point(coord),turf.point(bcoord),{units: 'miles'});
   var matchpt=turf.nearestPointOnLine(network[inlinkid],turf.point(coord),{units: 'miles'});
   var matchc=matchpt.geometry.coordinates;
   if (matchc==acoord && adist>disttol) return true;
   if (matchc==bcoord && bdist>disttol) return true;
   return false;
}
   